- name: Set keycloak deployment instances
  set_fact:
    keycloak_replicas: "{{ inv_replicas.keycloak.app }}"
    instances_count: "{{ inv_replicas.keycloak.app -1 | int }}" # e.g. 2 replicas: keycloak-0, keycloak-1

- name: Set keycloak base extensions
  set_fact:
    idm_extensions:
      - https://github.com/aerogear/keycloak-metrics-spi/releases/download/2.5.3/keycloak-metrics-spi-2.5.3.jar

- name: Append theme extension
  set_fact:
    idm_extensions: "{{ idm_extensions + [ inv_idm.keycloak.theme_url ] }}"
  when: inv_idm.keycloak.theme_url is defined

- name: Deploy Keycloak custom resource
  kubernetes.core.k8s:
    definition: "{{ item }}"
    namespace: "{{ k8s_namespace }}"
    kubeconfig: "{{ k8s_config }}"
    context: "{{ k8s_context }}"
    state: present
  loop:
    - "{{ lookup('template', 'templates/04_idm_keycloak/deployment/keycloak.yaml') | from_yaml_all | list }}"
  register: keycloak_cr_deploy

- name: Wait for k8s to catch up
  wait_for:
    timeout: 60
  when: keycloak_cr_deploy.changed

- name: Wait for Start-Up of all Keycloak instances
  kubernetes.core.k8s_info:
    kind: Pod
    namespace: "{{ k8s_namespace }}"
    kubeconfig: "{{ k8s_config }}"
    context: "{{ k8s_context }}"
    name: "keycloak-{{ item }}"
    wait: yes
    wait_sleep: 10
    wait_timeout: 300
    wait_condition:
      type: Ready
      status: True
  with_sequence: start=0 end={{ instances_count }}

- name: Deploy custom Keycloak Ingress
  kubernetes.core.k8s:
    definition: "{{ item }}"
    namespace: "{{ k8s_namespace }}"
    kubeconfig: "{{ k8s_config }}"
    context: "{{ k8s_context }}"
    state: present
  loop:
    - "{{ lookup('template', 'templates/04_idm_keycloak/deployment/keycloak-ingress.yaml') | from_yaml }}"
